---
title: Computational Ghosts
desc: seasonally-appropriate spooky computer stories
timestamp: 2022-10-25T22:46:00-04:00
---

Over the past few years I have interacted with (and right now am currently interacting with) computers that are haunted. Computer ghosts are nasty creatures, evading all attempts to exorcize them via conventional means. One may spend hours - or even days - scouring the internet for any thread even vaguely related to the problem caused by the ghost, test every "solution" offered, and still make no progress in banishing the ghost.

Most computer ghosts share the following characteristics:
 - They arise from the interaction between hardware and software
 - Their actual source is very difficult to locate
 - They resist all efforts to be fixed, even using solutions that others claim to "work on their machine"
 - Sometimes, trying to fix a ghost-induced problem can make it worse
 - Occasionally, even a complete reinstall doesn't banish the ghost

Following are three ghosts I have encountered, in chronological order.

In high school I participated in a robotics program. We would often use robots from previous years for testing purposes. One robot had an issue where the wheels could only be set to three velocities: off and maximum speed in either direction. Initially this problem was confined to one side of the robot, but over time it began to spread to the other side. It persisted even after using the bare minimum code required to operate the motors and replacing all of the motors and encoders on that side.

Believe it or not, the computer I am currently using is haunted. When at my desk I connect it to an external monitor, otherwise I just use the laptop screen. The ghost only manifests in the latter configuration. Occasionally, all windows on the system will stop responding (they won't recieve input or draw to the screen). For terminals the only option is SIGKILL, however GUI applications can eventually resume normal operation.

Recently, I have been assisting a friend with installing Linux on their laptop. Initially it was working pretty well, but recently sound has stopped working entirely. After hours of troubleshooting I managed to re-enable the HDMI sound device, but the laptop speaker remains missing.

May your electronics forever be ghost-free.
